# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.master_server import MastersrvAddr
from twnet_parser.packer import pack_packed_addresses
from typing import Literal

class MsgList(PrettyPrint):
    def __init__(
            self,
            servers: list[MastersrvAddr] = []
    ) -> None:
        self.message_type: Literal['connless'] = 'connless'
        self.message_name: str = 'connless.list'
        self.message_id: list[int] = [255, 255, 255, 255, 108, 105, 115, 50]

        self.servers: list[MastersrvAddr] = servers

    def __iter__(self):
        yield 'message_type', self.message_type
        yield 'message_name', self.message_name
        yield 'message_id', self.message_id

        yield 'servers', self.servers

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.servers = unpacker.get_packed_addresses()
        return True

    def pack(self) -> bytes:
        return pack_packed_addresses(self.servers)