# generated by scripts/generate_messages.py

from typing import Any, Dict

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int
import twnet_parser.enum6 as enum6

class ObjProjectile(PrettyPrint):
    def __init__(
            self,
            x: int = 0,
            y: int = 0,
            vel_x: int = 0,
            vel_y: int = 0,
            type: int = enum6.Weapon.HAMMER.value,
            start_tick: int = 0
    ) -> None:
        self.item_name: str = 'item.projectile'
        self.type_id: int = 2
        self.id: int = 0
        self.size: int = 6

        self.x: int = x
        self.y: int = y
        self.vel_x: int = vel_x
        self.vel_y: int = vel_y
        self.type: int = type
        self.start_tick: int = start_tick

    def __iter__(self):
        yield 'item_name', self.item_name
        yield 'type_id', self.type_id
        yield 'id', self.id
        yield 'size', self.size

        yield 'x', self.x
        yield 'y', self.y
        yield 'vel_x', self.vel_x
        yield 'vel_y', self.vel_y
        yield 'type', self.type
        yield 'start_tick', self.start_tick

    def to_dict_payload_only(self) -> Dict[str, Any]:
        return {
            'x': self.x,
            'y': self.y,
            'vel_x': self.vel_x,
            'vel_y': self.vel_y,
            'type': self.type,
            'start_tick': self.start_tick
        }

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, unpacker: Unpacker) -> bool:
        self.x = unpacker.get_int()
        self.y = unpacker.get_int()
        self.vel_x = unpacker.get_int()
        self.vel_y = unpacker.get_int()
        self.type = unpacker.get_int() # enum WEAPON
        self.start_tick = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.x) + \
            pack_int(self.y) + \
            pack_int(self.vel_x) + \
            pack_int(self.vel_y) + \
            pack_int(self.type) + \
            pack_int(self.start_tick)